---

.qa_git:
  image: registry.gitlab.com/jhctech-oss/code-quality/git:v0.4
  stage: qa

.qa_check_mr_file_changes:
  extends: .qa_git
  script:
    - |
      git diff --name-status origin/master ${FILENAME} > changes.out
      if [ -s ./changes.out ]; then
        echo "Changes are present in ${FILENAME} between this branch and master."
      else
        echo "Changes not present in ${FILENAME} between this branch and master. Consider documenting changes before merging."
        exit 1
      fi
  only:
    - merge_requests
  allow_failure: true

.run_master: &run_master
  if: '$CI_COMMIT_REF_NAME == "master" || $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "master"' # Will run on the master branch or MRs into master
  when: always

.run_tagged: &run_tagged
  if: '$CI_COMMIT_TAG' # If this ref is tagged
  when: always

stages:
  - qa

qa:check_changelog_edits:
  variables:
    FILENAME: CHANGELOG.md
  extends: .qa_check_mr_file_changes

qa:check_readme_edits:
  variables:
    FILENAME: README.md
  extends: .qa_check_mr_file_changes

qa:check_top_level_readme:
  extends: .qa_git
  script:
    - |
      FILE="README.md"
      if [ -f $FILE ]; then
        echo "File $FILE exists."
      else
        echo "File $FILE does not exist."
        exit 1
      fi
  rules:
    - *run_master
    - *run_tagged

qa:check_top_level_changelog:
  extends: .qa_git
  script:
    - |
      FILE="CHANGELOG.md"
      if [ -f $FILE ]; then
        echo "File $FILE exists."
      else
        echo "File $FILE does not exist."
        exit 1
      fi
  rules:
    - *run_master
    - *run_tagged

qa:markdownlint:
  extends: .qa_git
  script: node markdownlint.js || node /usr/lib/git_utils/markdownlint.js
  rules:
    - changes: # Will include the job and set to when:manual if any of the follow paths match a modified file.
      - "**/*.md"
      when: always
    - *run_master
    - *run_tagged
